"use strict";
(function () {
    var color_number_to_string_array = ["normal", "bold", "underline", "underline bold", "italic", "italic bold", "underline italic", "underline italic bold", "outline", "superbold", "shadow", "transparent"];
    var hilight_textcolor = hidemaruGlobal.getconfigcolor(34, 0);
    var hilight_backcolor = hidemaruGlobal.getconfigcolor(34, 1);
    var r = hidemaruGlobal.getconfigcolor(34, 2);
    var hilight_style = "normal";
    if (r >= 0 && r < color_number_to_string_array.length)
        hilight_style = color_number_to_string_array[r];
    var curdir = hidemaruGlobal.directory();
    var pipe_exe = hidemaru.getVar("$pipe_exe");
    var random_value = hidemaru.getVar("$random_value");
    var proc;
    var hmoutputdll = hidemaru.loadDll(hidemaruGlobal.hidemarudir() + "\\HmOutputPane.dll");
    var hmhandle = hidemaruGlobal.hidemaruhandle(0);
    function CloseOutputPanel() {
        hidemaru.postExecMacroMemory('#dll = loaddll(hidemarudir + "\\\\HmOutputPane.dll");#h = dllfunc(#dll,"GetWindowHandle",' + String(hmhandle) + ');##_ = sendmessage(#h,0x111,1001,0);freedll #dll;');
    }
    function ClearOutputPanel() {
        hidemaru.postExecMacroMemory('#dll = loaddll(hidemarudir + "\\\\HmOutputPane.dll");##_ = dllfunc(#dll,"Output",' + String(hmhandle) + ',"");#h = dllfunc(#dll,"GetWindowHandle",' + String(hmhandle) + ');##_ = sendmessage(#h,0x111,1009,0);freedll #dll;');
    }
    function OutputPanel(s) {
        hmoutputdll.dllFunc.Output(hmhandle, s + "\r\n");
    }
    function ClearColorMarkers() {
        var json = {
            layer: "fortex_latexmk",
            clear: 1,
        };
        hidemaruGlobal.colormarker(JSON.stringify(json));
    }
    CloseOutputPanel();
    function ChangeExtension(file, ext) {
        var p = file.lastIndexOf(".");
        if (p == -1)
            return file + "." + ext;
        var b = file.lastIndexOf("\\");
        if (b > p)
            return file + "." + ext;
        else
            return file.slice(0, p) + "." + ext;
    }
    function escapeRegExp(s) {
        return s.replace(/[-\/\\^$*+?.()|\[\]{}]/g, '\\$&');
    }
    function onLatexmkFailure(s) {
        var r = s.indexOf(":");
        var dousa = ',' + s.slice(0, r) + ',';
        var file = s.slice(r + 1);
        var title_warn = (dousa.indexOf(",title,") != -1);
        var output = (dousa.indexOf(",output,") != -1);
        var mark = (dousa.indexOf(",mark,") != -1);
        var message = (dousa.indexOf(",message,") != -1);
        var contentall = hidemaru.loadTextFile(ChangeExtension(file, "log"));
        if (contentall == null) {
            OutputPanel("(Latexmk) Error found: see the console or the log file\r\n");
            return;
        }
        var contents = contentall.split("\n");
        var error_fl_reg = new RegExp("^([^:]*):([0-9]+): *(.*)$");
        var error_line_reg = new RegExp('^l\.[0-9]+ *(.*)');
        var errfile = '';
        var errline = 0;
        var errmsg = '';
        var errline1_str = '';
        var errline2_str = '';
        var outputmsg = '';
        var is_undef_error = false;
        for (var line = 0; line < contents.length; ++line) {
            var m = contents[line].match(error_fl_reg);
            if (m != null) {
                errfile = m[1];
                errline = Number(m[2]);
                errmsg = m[3];
                if (errmsg == "Undefined control sequence.")
                    is_undef_error = true;
                outputmsg = outputmsg + errfile + "(" + String(errline) + "):" + errmsg + "\r\n";
                ++line;
                while (line < contents.length) {
                    var m = contents[line].match(error_line_reg);
                    if (m != null) {
                        errline1_str = contents[line];
                        if (line < contents.length - 1) {
                            ++line;
                            errline2_str = contents[line];
                        }
                        outputmsg = outputmsg + errline1_str + "\r\n" + errline2_str + "\r\n";
                        break;
                    }
                    outputmsg = outputmsg + contents[line] + "\r\n";
                    ++line;
                }
                break;
            }
        }
        if (output) {
            if (outputmsg != '')
                OutputPanel(outputmsg);
            else
                OutputPanel("(Latexmk) Error found: see the console or the log file");
        }
        if (mark) {
            ClearColorMarkers();
            function to_colorstr(n) {
                if (n == 0xFFFFFFFF)
                    return "#000000";
                var s = n.toString(16);
                s = "000000".slice(0, 6 - s.length) + s;
                return "#" + s.slice(4, 6) + s.slice(2, 4) + s.slice(0, 2);
            }
            var json = {
                layer: "fortex_latexmk",
                kind: "erase",
                unit: "wcs",
                line1: errline,
                line2: errline,
                col1: 0,
                col2: 9999,
                text: to_colorstr(hilight_textcolor),
                back: to_colorstr(hilight_backcolor),
                style: hilight_style,
            };
            if (is_undef_error) {
                var m = errline1_str.match(/^l\.[0-9]+ *(.*)(\\[^\\ ]*) *$/);
                if (m != null) {
                    var undefcs_pre = m[1];
                    var undefcs = m[2];
                    if (undefcs_pre.slice(0, 3) == "...")
                        undefcs_pre = undefcs_pre.slice(3);
                    var str = hidemaru.getLineText(errline);
                    if (str != undefined) {
                        var reg = new RegExp(escapeRegExp(undefcs_pre + undefcs) + " *" + escapeRegExp(errline2_str.replace(/^ */, "")));
                        m = str.match(reg);
                        if (m != null) {
                            if (typeof (m.index) == "number") {
                                var r = m.index;
                                json.col1 = r + undefcs_pre.length;
                                json.col2 = r + undefcs_pre.length + undefcs.length;
                            }
                        }
                    }
                }
            }
            hidemaruGlobal.colormarker(JSON.stringify(json));
        }
    }
    function onLatexmkSuccess(s) {
        var r = s.indexOf(":");
        var mode = "," + s.slice(0, r) + ",";
        var ss = s.slice(r + 1);
        r = ss.indexOf(":", 3);
        var from, to;
        if (r == -1) {
            from = ss;
            to = "";
        }
        else {
            from = ss.slice(0, r);
            to = ss.slice(r + 1);
        }
        var mark = (mode.indexOf(",mark,") != -1);
        var opentmp = (mode.indexOf(",opentmp,") != -1);
        if (mark)
            ClearColorMarkers();
        if (opentmp) {
            var fso = hidemaru.createObject("Scripting.FileSystemObject");
            fso.CopyFile(from, to);
        }
        CloseOutputPanel();
    }
    function onCompiled(s) {
        var r = s.indexOf(" ");
        if (r == -1)
            r = s.length;
        var dousa = s.slice(0, r);
        var nokori = s.slice(r + 1);
        if (dousa == "failure") {
            ClearOutputPanel();
            function onLatexmkFailure_aux() {
                if (hidemaru.isMacroExecuting()) {
                    hidemaru.setTimeout(onLatexmkFailure_aux, 50);
                    return;
                }
                onLatexmkFailure(nokori);
            }
            hidemaru.setTimeout(onLatexmkFailure_aux, 50);
        }
        else if (dousa == "success")
            onLatexmkSuccess(nokori);
        else if (dousa == "compiling") {
            if (hmoutputdll.dllFunc.GetWindowHandle(hmhandle) != 0) {
                OutputPanel("処理中...");
            }
        }
    }
    function mainAsync() {
        if (hidemaru.isMacroExecuting()) {
            hidemaru.setTimeout(mainAsync, 50);
            return;
        }
        var proc = hidemaru.runProcess('"' + pipe_exe + '" start ' + random_value, curdir, "stdio", "utf8");
        if (proc == null) {
            OutputPanel("補助プログラムの起動に失敗．Latexmkからの通知が無視されます．");
            return;
        }
        proc.stdOut.onReadLine(function (s) {
            if (typeof (s) == "string") {
                onCompiled(s.replace(/^\s+|\s+$/g, ""));
            }
        });
    }
    hidemaru.setTimeout(mainAsync, 50);
})();
